local changed = false
local queue = 0
local queueContinent = 0
local pois ={}
local bypass = false
local dummyFrame=CreateFrame("FRAME");
dummyFrame:RegisterEvent("WORLD_MAP_UPDATE");
dummyFrame:RegisterEvent("TAXIMAP_OPENED");
dummyFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
dummyFrame:RegisterEvent("PLAYER_CONTROL_LOST");

SLASH_FQ1 = '/fq';
function SlashCmdList.FQ()
	queue = 0
	print("Flight queue cleared")
end

function OnUpdateHandler(poi)
	if poi.landmarkType == LE_MAP_LANDMARK_TYPE_TAXINODE then
		poi:SetSize(16,16)
	end
end

function OnEnterHandler(poi)
	if poi.landmarkType == LE_MAP_LANDMARK_TYPE_TAXINODE then
		for i=1,#nodes do
			if nodes[i].name == poi.name then
				GameTooltip:SetOwner (poi, "ANCHOR_RIGHT")
				GameTooltip:SetText ("FlightQueue: "..nodes[i].name)
				GameTooltip:Show()
			end
		end
	end
end

function ClickHandler(poi,button)
	if button=="LeftButton" and poi.landmarkType == LE_MAP_LANDMARK_TYPE_TAXINODE then
		for i=1,#nodes do
			if nodes[i].name == poi.name then
				local c,_= GetCurrentMapContinent()
				if queue == nodes[i].slotIndex then
					queue = 0
					print("Flight queue cleared")
					return
				elseif fcontinent[c]~=nil then
					queue = nodes[i].slotIndex
					queueContinent = c
					print("Flight queued: "..nodes[i].name)
					return
				end
			end
		end
		if queueContinent then
			print("Undiscovered taxi node.")
		else
			print("You have not visited a flight master on this continent yet.")
		end
	end

end

function frameEventHandle(_,event)
	if event == "ZONE_CHANGED_NEW_AREA" then
		changed = true
	end
	if event == "TAXIMAP_OPENED" then
		if nodes == nil then
			nodes = GetAllTaxiNodes()
		end
		local nnodes = GetAllTaxiNodes()
		for k in pairs(nnodes) do
			local found = false
			for K in pairs(nodes) do
				if nodes[K].name == nnodes[k].name then
					found = true
				end
			end
			if found == false then
				table.insert(nodes,nnodes[k])
			end
		end
		bypass=false
		local c,_=GetCurrentMapContinent()
		if queue > 0 and queueContinent==c and IsShiftKeyDown()~=true then
			TakeTaxiNode(queue);
			for i=1,20 do
				C_Timer.After(i/4,function () TakeTaxiNode(queue);end)--every 1/4 second for 5 seconds (20/4)
			end
		elseif IsShiftKeyDown() then
			bypass=true
		end
	end
	if event == "PLAYER_CONTROL_LOST" and bypass==false then
		local c,_=GetCurrentMapContinent()
		if queue > 0 and queueContinent==c then
			C_Timer.After(5,function ()
				if UnitOnTaxi("player") then
					queue = 0
				end
			end)
		end
	end
	if event == "WORLD_MAP_UPDATE" then
		if changed then
			local NewContinent,_ = GetCurrentMapContinent()
			if fcontinent == nil then
				fcontinent={}
			end
			for k in pairs(fcontinent) do
				fcontinent[k]=false
			end
			if NewContinent>0 then
				if fcontinent[NewContinent]==nil then
					print("FlightQueue: New Continent discovered. Visit a Flight Master to load new taxi nodes.")
				end
				fcontinent[NewContinent]=true
			end
			changed = false
		end
		if WorldMapFrame:IsVisible() and nodes~=nil and #nodes>0 then
			for f=1,GetNumMapLandmarks() do
				local poi = "WorldMapFramePOI"..f
				if pois[poi] == nil then
					pois[poi]=true
					_G[poi]:HookScript("OnEnter",OnEnterHandler)
					_G[poi]:HookScript("OnMouseDown", ClickHandler)
					_G[poi]:HookScript("OnLeave",function()
						GameTooltip_Hide()
					end)
					_G[poi]:HookScript("OnUpdate",OnUpdateHandler)
				end
				if _G[poi].landmarkType == LE_MAP_LANDMARK_TYPE_TAXINODE then
					_G[poi]:SetFrameStrata("DIALOG")
				elseif _G[poi].landmarkType == LE_MAP_LANDMARK_TYPE_NORMAL then
					_G[poi]:SetFrameStrata("HIGH")
				end
			end
		end
	end
end
dummyFrame:SetScript("OnEvent",frameEventHandle);
